using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.SessionState;


namespace AquaforestTIFFServerAudit
{
    public class TIFFServerAudit
    {

        public static bool securityCheck(string fileName, string action, string AUTH_USER)
        {
            // Return False to disable access
            return true;
        }
        public static void logAction(string action)
        {
            // Action is one of :
            // VIEW, PRINT, PDF, SAVEPDF, GETANNOTATIONS, SAVEANNOTATIONS, EDIT, SAVEEDIT
            try
            {
                string status = "OK"; // Default
                string auditFileName = HttpContext.Current.Session["ts_audit_file"].ToString();

                if (auditFileName == null || auditFileName == "")
                    return;

                string fileName = HttpContext.Current.Request["FN"];
                string PC = HttpContext.Current.Request["PC"];
                string AUTH_USER = HttpContext.Current.Request.ServerVariables["AUTH_USER"];
                string REMOTE_HOST = HttpContext.Current.Request.ServerVariables["REMOTE_HOST"];

                if (action == "EDIT" || action == "SAVEEDIT")
                {
                    fileName = HttpContext.Current.Request["filename"];
                }
                else
                if (action == "GETANNOTATIONS")
                {
                    fileName = HttpContext.Current.Server.MapPath(HttpContext.Current.Request["an_url"]);
                }
                else
                if (action == "SAVEANNOTATIONS")
                {
                    fileName = HttpContext.Current.Request["anfile"];
                }



                /* 
                 * Any Security Checks May Go Here and Terminate Response with 
                 * HttpContext.Current.Response.End() before or after writing log entry
                */

                if (!securityCheck(fileName,action,AUTH_USER))
                {
                    if (action == "GETANNOTATIONS")
                    {
                        HttpContext.Current.Response.Write("<ts_annot></ts_annot>");
                        HttpContext.Current.Response.End();
                    }
                    if (PC == "Y")
                    {
                        HttpContext.Current.Response.Write("afPageCount=-5;afMessage='You do not have permission to access this file.  Please contact your system administrator.';");
                        HttpContext.Current.Response.End();
                    }
                    else
                    {
                        HttpContext.Current.Response.Clear();
                        HttpContext.Current.Response.End();
                    }
                }

              
                if (action == "VIEW" && PC != "Y")
                {
                    // Only log for the initial page count request, not for each page 
                    return;
                }
    			
                System.IO.StreamWriter auditFile = new System.IO.StreamWriter(auditFileName, true);
                if (auditFile != null)
				{
                    auditFile.WriteLine(DateTime.Now + "," + action+","+status+","+fileName+","+AUTH_USER+","+REMOTE_HOST+","+HttpContext.Current.Request.Url);
                    auditFile.WriteLine();
                    auditFile.Flush();
                    auditFile.Close();
				}
			}
			catch(Exception)
			{
			}
		}
    }
}
